package com.kingdee.eas.custom.shengshen.utils;

import com.itextpdf.text.pdf.AcroFields;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.kingdee.bos.BOSException;
import net.lingala.zip4j.core.ZipFile;
import net.lingala.zip4j.exception.ZipException;
import net.lingala.zip4j.model.ZipParameters;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class PDFFillInformationUtil {
    /**
     * pdf
     * @param file ԭʼļ
     * @param field map<String,String> key Ϊֶvalue Ϊֵ
     * @return ļ  ļΪbyte[]
     */
    public File fillInformation(byte[] file, Map<String,String> field,String tempFilePath,String fileName) throws IOException {
        try {
            System.setProperty("javax.xml.parsers.DocumentBuilderFactory","com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl");
            // ȡPDFģ
            PdfReader pdfReader = new PdfReader(file);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            // ͸PDFļ
            PdfStamper pdfStamper = new PdfStamper(pdfReader, baos);
            AcroFields form = pdfStamper.getAcroFields();
            // ֶ
            Iterator<Map.Entry<String, String>> iterator = field.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, String> entry = iterator.next();
                String key = entry.getKey();
                String value = entry.getValue();
                //ֵֶ
                form.setField(key, value);
            }
            //ɺpdf ڱ༭
            pdfStamper.setFormFlattening(false);
            // ر޸ͷԴ
            pdfStamper.close();
            pdfReader.close();
            File outFile = new File(tempFilePath+"/"+fileName);
            if (!outFile.createNewFile()) {
                throw new RuntimeException("pdf ʧܣ");
            }
            FileOutputStream fos = new FileOutputStream(outFile);
            baos.writeTo(fos);
            fos.close(); // رͷԴ
            return  outFile;
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("pdf ʧܣ");
        }
    }
    /**
     * ѹ
     *
     * @param destFileName
     * @param files
     * @return
     */
    public static String compress(String destFileName, List<File> files) throws BOSException {
        ZipParameters parameters = new ZipParameters();
        parameters.setCompressionMethod(8);
        parameters.setCompressionLevel(5);
        try {
            ZipFile zipFile = new ZipFile(destFileName);
            for (int i = 0; i < files.size(); ++i) {
                File file = files.get(i);
                zipFile.addFile(file, parameters);
            }
            return destFileName;
        } catch (ZipException var9) {
            var9.printStackTrace();
            throw new BOSException(var9.getMessage());
        }
    }
}
